"use strict";
// client side code
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_WS_PORT = void 0;
exports.DEFAULT_WS_PORT = 27495;
class Tes {
    send(method, data) {
        var _a;
        (_a = this.socket) === null || _a === void 0 ? void 0 : _a.send(JSON.stringify({ method, data }));
    }
    handle(str) {
        var _a;
        const { message } = JSON.parse(str);
        switch (message) {
            case 'started':
                (_a = this.startResolve) === null || _a === void 0 ? void 0 : _a.call(this);
                break;
        }
    }
    async start(options = {}) {
        const { wsUrl, ...tOptions } = options;
        const resultWsUrl = wsUrl !== null && wsUrl !== void 0 ? wsUrl : `ws://localhost:${exports.DEFAULT_WS_PORT}/path/doesnt/matter`;
        let reject;
        this.startPromise = new Promise((res, rej) => {
            this.startResolve = res;
            reject = rej;
        });
        this.socket = new WebSocket(resultWsUrl);
        this.socket.addEventListener('open', (_event) => {
            console.log('WebSocket connection opened', resultWsUrl);
            this.send('start', tOptions);
        });
        this.socket.addEventListener('message', (event) => {
            console.log('message', event.data);
            this.handle(event.data);
        });
        this.socket.addEventListener('error', (event) => {
            console.log('WebSocket connection failed', event);
            reject();
        });
        return this.startPromise;
    }
    async add(userInterceptor) {
        await this.startPromise;
        this.socket.send(JSON.stringify({ method: 'add', data: userInterceptor }));
        return () => {
            this.socket.send(JSON.stringify({ method: 'remove', data: userInterceptor }));
        };
    }
    async stop() {
        // @todo stopPromise, and other promises too. Need some approach here.
        await this.startPromise;
        this.socket.send(JSON.stringify({ method: 'stop' }));
        this.socket.close();
    }
}
exports.default = new Tes();
