"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.debug = void 0;
const tslib_1 = require("tslib");
const signale_1 = require("signale");
const debug_1 = tslib_1.__importDefault(require("debug"));
let logLevel = process.env.DEBUG_LL || 'info';
let resultLogLevel = 'debug';
if (logLevel === 'debug') {
    resultLogLevel = 'info';
}
if (logLevel === 'info') {
    resultLogLevel = 'debug';
}
const options = {
    disabled: false,
    interactive: false,
    logLevel: resultLogLevel,
    scope: 'teremock',
    secrets: [],
    stream: process.stdout,
    types: {
        debug: {
            badge: '•',
            color: 'grey',
            label: 'debug',
            logLevel: 'info',
        },
        info: {
            badge: 'ø',
            color: 'green',
            label: 'info',
            logLevel: 'debug',
        },
        get: {
            badge: '»',
            color: 'gray',
            label: 'storage.get',
            logLevel: 'info',
        },
        set: {
            badge: 'œ',
            color: 'red',
            label: 'storage.set',
            logLevel: 'warn',
        },
    },
};
const logger = new signale_1.Signale(options);
exports.default = logger;
const loggersMap = {};
function debug(key) {
    if (!loggersMap[key]) {
        loggersMap[key] = debug_1.default(key);
    }
    return loggersMap[key];
}
exports.debug = debug;
